#include "mpi.h"
#include "pnmParser/pnmParser.h"
#include "ant/ant.h"
#include <stdio.h>
#include <string.h>

colors inspect_and_act(colors ** old, colors ** new, int i, int j){
   unsigned int aliveR, aliveG, aliveB;
   colors color;

   //Red
   color.r = (old[i-1][j-1].r + old[i-1][j+0].r + old[i-1][j+1].r + old[i+0][j-1].r +old[i+0][j+0].r + old[i+0][j+1].r + old[i+1][j-1].r + old[i+1][j+0].r + old[i+1][j+1].r)/9;
   
   aliveR = 8;
   if( old[i-1][j-1].r < 127)
      aliveR--;
   if( old[i-1][j+0].r < 127)
      aliveR--;
   if( old[i-1][j+1].r < 127)
      aliveR--;
   if( old[i+0][j-1].r < 127)
      aliveR--;
   if( old[i+0][j+1].r < 127)
      aliveR--;
   if( old[i+1][j-1].r < 127)
      aliveR--;
   if( old[i+1][j+0].r < 127)
      aliveR--;
   if( old[i+1][j+1].r < 127)
      aliveR--;
      
   if (aliveR == 3){
      //ideal - reproduces
      if (new[i][j].r < 127){
         color.r = 127 + (color.r % 127);
      }
   }else if (aliveR < 2){
      //underpopulation - dyes
      color.r = color.r % 127;
   }else if ( aliveR > 3){
      //overpupulation - dyes
      color.r = color.r % 127;
   } else {
      //two, nothing happens
      color.r =  old[i][j].r;
   }

   //Green
   color.g = (old[i-1][j-1].g + old[i-1][j+0].g + old[i-1][j+1].g + old[i+0][j-1].g +old[i+0][j+0].g + old[i+0][j+1].g + old[i+1][j-1].g + old[i+1][j+0].g + old[i+1][j+1].g)/9;
   
   aliveG = 8;
   if( old[i-1][j-1].g < 127)
      aliveG--;
   if( old[i-1][j+0].g < 127)
      aliveG--;
   if( old[i-1][j+1].g < 127)
      aliveG--;
   if( old[i+0][j-1].g < 127)
      aliveG--;
   if( old[i+0][j+1].g < 127)
      aliveG--;
   if( old[i+1][j-1].g < 127)
      aliveG--;
   if( old[i+1][j+0].g < 127)
      aliveG--;
   if( old[i+1][j+1].g < 127)
      aliveG--;
      
   if (aliveG == 3){
      //ideal - reproduces
      if (new[i][j].g < 127){
         color.g = 127 + (color.g % 127);
      }
   }else if (aliveG < 2){
      //underpopulation - dyes
      color.g = color.g % 127;
   }else if ( aliveG > 3){
      //overpupulation - dyes
      color.g = color.g % 127;
   } else {
      //two, nothing happens
      color.g =  old[i][j].g;
   }
   
   
   //Blue
   color.b = (old[i-1][j-1].b + old[i-1][j+0].b + old[i-1][j+1].b + old[i+0][j-1].b +old[i+0][j+0].b + old[i+0][j+1].b + old[i+1][j-1].b + old[i+1][j+0].b + old[i+1][j+1].b)/9;
   
   aliveB = 8;
   if( old[i-1][j-1].b < 127)
      aliveB--;
   if( old[i-1][j+0].b < 127)
      aliveB--;
   if( old[i-1][j+1].b < 127)
      aliveB--;
   if( old[i+0][j-1].b < 127)
      aliveB--;
   if( old[i+0][j+1].b < 127)
      aliveB--;
   if( old[i+1][j-1].b < 127)
      aliveB--;
   if( old[i+1][j+0].b < 127)
      aliveB--;
   if( old[i+1][j+1].b < 127)
      aliveB--;
      
   if (aliveB == 3){
      //ideal - reproduces
      if (new[i][j].b < 127){
         color.b = 127 + (color.b % 127);
      }
   }else if (aliveB < 2){
      //underpopulation - dyes
      color.b = color.b % 127;
   }else if ( aliveG > 3){
      //overpupulation - dyes
      color.b = color.b % 127;
   } else {
      //two, nothing happens
      color.b =  old[i][j].b;
   }

   return color;
}

void iter(int count,int id, int nodes){
   
   //Inicialização
   
   // Todo mundo carrega a imagem
   int border = 1;
   int i,j,mark,rows_slice;
   Map m = new_map("horse.pnm");
   
   rows_slice = (m->rows / nodes); 
   
   //Ant ant = new_ant(m->rows/2,m->cols/2,-1,0,10);   
   
   
   colors ** new = get_empty_slice(m,rows_slice,m->cols,border);
   colors ** transf = get_empty_slice(m,rows_slice,m->cols,0);
   colors ** old = get_slice(m,id*rows_slice,0,(id+1)*rows_slice-1,m->cols-1,border);
   colors ** tmp;
   char name[33];

   MPI_Status status;
   count++; //Workarround para fazer uma interação a mais. 
   mark = 0;
   //Preencher a borda
   while (mark < count){   

      // Pega borda do slice adjacente e sobrepor na borda do proprio slice
      // Se o id for maior que 0 manda e pede para vizinho de cima
      // Se o id for menor que num de nodes manda e pede para vizinho de baixo

      if(id > 0) {
         //printf("Sender id: %d. Destination: %d\n", id, id-1);
         MPI_Send(old[border], m->cols, MPI_UNSIGNED_CHAR, id-1, 99, MPI_COMM_WORLD);
      } 
      if (id < (nodes - 1)) {
         //printf("Sender id: %d. Destination: %d\n", id, id+1);
         MPI_Send(old[rows_slice + border - 1], m->cols, MPI_UNSIGNED_CHAR, id+1, 99, MPI_COMM_WORLD);
      }
     
      if(id > 0) {
         //printf("Receiver id: %d. Source: %d\n", id, id-1);
         MPI_Recv(old[0], m->cols, MPI_UNSIGNED_CHAR, id-1, 99, MPI_COMM_WORLD, &status);
      }
      if (id < (nodes - 1)) {
         //printf("Receiver id: %d. Source: %d\n", id, id+1);
         MPI_Recv(old[rows_slice + 2*border - 1], m->cols, MPI_UNSIGNED_CHAR, id+1, 99, MPI_COMM_WORLD, &status);
      }

 
      for ( i = 0 + border; i < (rows_slice + border); i++){
         for ( j = 0 + border;  j < (m->cols + border); j++){
            new[i][j] = inspect_and_act(old,new,i,j);
         }
      }
      
   
      //langton_ant(new, old,ant);
      
      mark++;
      
      if (mark % 10 == 1){
         if (id == 0){
            int tag;
            set_slice(m,0,0,rows_slice-1,m->cols-1,border,new);   
            for (i = 1; i < nodes; i++){
               for (tag = 0; tag < rows_slice; tag++){
                  MPI_Recv(transf[tag], m->cols,MPI_UNSIGNED_CHAR,i,tag,MPI_COMM_WORLD,&status);
                  //printf("Joining %d\n",i);
               }
               set_slice(m,i*rows_slice,0,(i+1)*rows_slice-1,m->cols-1,0,transf);   
            }
         
            sprintf(name,"%05d.pnm",mark);
            save_pnm(m,name);
         } else{
            //printf("Reducing %d\n",id);
            for (i = border; i < (rows_slice+border); i++){
               MPI_Send(new[i], m->cols, MPI_UNSIGNED_CHAR, 0,i-border, MPI_COMM_WORLD);
            }
         }
      
      }
      
      tmp = old;
      old = new;
      new = tmp;
   }
      
   
   free(m);
   free(new);
   free(old);
   //free(ant);
}

int main(int argc, char ** argv){
   int nodes, id;
   MPI_Init(&argc,&argv);
   MPI_Comm_size(MPI_COMM_WORLD,&nodes);
   MPI_Comm_rank(MPI_COMM_WORLD,&id);
   
   iter(atoi(argv[1]),id,nodes);

   MPI_Finalize();
   return 0;
}
